libname wiilsu 'C:\Users\cancxs\Desktop\wiilsu, jun 2014\investigating your data with 4 powerful SAS languages\data';
proc freq data=wiilsu.criminal;
tables statute_description;
run;
* data step;
data sounds;
set wiilsu.criminal;
where name_age_of_person_charged =* "&sonic";
run;
* that helps. but why does my search for alfred return albert;
%let sonic=alfred;
data &sonic;
set wiilsu.criminal;
where name_age_of_person_charged =* "&sonic";
run;
*coz the soundex algorithm does this. also becoz soundex looks for the 1st word in your string & matches that with what you asked for;

%let sonic=Alfred;
* data step;
data &sonic;
set wiilsu.criminal;
where name_age_of_person_charged contains "&sonic";
run;

*data step stringing out;
data wiilsu.string;
set wiilsu.criminal;
if name_age_of_person_charged ne ' '
then age=scan(name_age_of_person_charged,-1);
nage=input(age,2.);
statute=scan(statute_description, 1, ' ');
city=scan(home_address__block__of_person_C,-2,',');
run;
options ls=150;

*PART III;
proc sql noprint;
select city ,count(city)  into : city, : citycoun
from wiilsu.string
group by city
order by 2 desc
;
%put &city= &citycoun=;
*validating proc sql & macro;
proc freq data=wiilsu.string order=freq;
tables city;
run;
* the boolean;
title "data for &city";
proc sql;
/*select  'Arrest#'n, 'Seq#'n, 'ICR #'n, Specific_Crime,  Statute_Description,  Arrest_Date/Time,  Name/Age_of_Person_Charged,*/
/* Home_Address_Block_of_Person_Charged, H, I,  var2,  ICR__2, specific_crime2*/

select  Specific_Crime, sum(nage < 18) 'Minor Age <18',
sum(nage between 18 and 21) 'Age 18-21', 
sum(nage between 22 and 35) 'Age 22-35', 
sum(nage between 36 and 50) 'Age 36-50', 
sum(nage > 51) 'Age 51 and older'
from WIILSU.string
where city="&City"
group by 1

;

*top 10 report;
proc sql;
select 



proc freq data=string;
tables name_age_of_person_charged;
run;

proc freq data=string order=freq;
tables home_address__block__of_person_C;
run;
and datepart(arrest_date_time)='16may2014'd;
run;

proc means data=string sum;
var nage;
class specific_crime;
where nage <=18;
run;
* perl;
data test;
set criminal;
where prxmatch(("/\(\D\D\)/"), statute_description) > 0 ;
run;
%let sonic=antony;






%let home = home_address_block_of_person_C;
data &home;

